#include <stdio.h>
#include <mpi.h>
#include <math.h>

int main(int argc, char *argv[])
{
  
  int  n=200; /* the number of intervals */
  int myid;
  int numprocs; /* the number of processors */
  int i, rc;
  float PI25DT = 3.14159265358979323842643;
  float array[1000];
  
  float mypi, h, x, a;
  float pi;
  float sum;
  
  MPI_Init(&argc, &argv);
  
  MPI_Comm_size(MPI_COMM_WORLD, &numprocs);
  
  MPI_Comm_rank(MPI_COMM_WORLD, &myid);

  /*Broadcast the value of 'n' from the root to other processors  */
  MPI_Bcast(&n, 1, MPI_INT, 0, MPI_COMM_WORLD);
    
  h = 1.0 /(double) n;
  
      sum = 0.0;
  
      for (i=myid+1; i<=n; i+=numprocs)
        {
          x = h *((double)i - 0.5);
          sum += 4.0/(1.0 + x*x);
        }
      mypi = h * sum;

  pi = 0.0; /* initialize the value to zero */
  
  /* Gather the values from the different processors to the root */
 
  MPI_Gather(&mypi, 1, MPI_FLOAT, array,  1, MPI_FLOAT, 0, MPI_COMM_WORLD);   

  /* for the root processor, do the addition */
  if (myid == 0) {
     for (i=0; i<numprocs; i++) {
         pi = pi + array[i];
     }
  }
  /*Broadcast the value of pi from the root to other processors  */
  MPI_Bcast(&pi, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);

  if (myid == 0)
     printf("pi is approximately %.16f, and the Error is %.16f\n", 
                 pi, fabs(pi - PI25DT));
  /* Print the Broadcast value of pi  */
  printf("\n Now I am broadcasting the values from each processor\n");
  MPI_Bcast(&pi, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);

   /* print the value of pi of each processor */
   printf("I am processor %4i, and  pi is approximately %.16f\n", 
                 myid, pi);  

  MPI_Finalize;
}

